local threat = AceLibrary("Threat-1.0")
local Epsilon=0.000000000000000001

--.MainTitle = What you see on the window title 
--.TopNames = Names of the entries for the top data
--.TopAmount = What we call the amount for the top
--.BotNames = Names of the entries for the bottom
--.BotMin = The minimum label for bottom
--.BotAvg = The average label for bottom
--.BotMax = The minimum label for bottom
--.BotAmount = Label for what the amount is on the bottom
local DetailTitles={}
DetailTitles.Attacks={
	TopNames = "Ability Name",
	TopAmount = "Damage",
	BotNames = "Type",
	BotMin = "Min",
	BotAvg = "Avg",
	BotMax = "Max",
	BotAmount = "Count"
}

DetailTitles.Resisted={
	TopNames = "Ability Name",
	TopAmount = "Resisted",
	BotNames = "Type",
	BotMin = "Min",
	BotAvg = "Avg",
	BotMax = "Max",
	BotAmount = "Count"
}

DetailTitles.DamagedWho={
	TopNames = "Player/Mob Name",
	TopAmount = "Damage",
	BotNames = "Attack Name",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Damage"
}

DetailTitles.DamageTime={
	TopNames = "Player/Mob Name",
	TopAmount = "Time (s)",
	BotNames = "Attack Name",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Time (s)"
}

DetailTitles.Heals={
	TopNames = "Heal Name",
	TopAmount = "Heal",
	BotNames = "Type",
	BotMin = "Min",
	BotAvg = "Avg",
	BotMax = "Max",
	BotAmount = "Count"
}

DetailTitles.HealedWho={
	TopNames = "Player/Mob Name",
	TopAmount = "Healed",
	BotNames = "Heal Name",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Healed"
}

DetailTitles.OverHeals={
	TopNames = "Heal Name",
	TopAmount = "Overheal",
	BotNames = "Type",
	BotMin = "Min",
	BotAvg = "Avg",
	BotMax = "Max",
	BotAmount = "Count"
}

DetailTitles.HealTime={
	TopNames = "Player/Mob Name",
	TopAmount = "Time (s)",
	BotNames = "Heal Name",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Time (s)"
}

DetailTitles.ActiveTime={
	TopNames = "Player/Mob Name",
	TopAmount = "Time (s)",
	BotNames = "Ability",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Time (s)"
}


DetailTitles.DOTs={
	TopNames = "Ability Name",
	TopAmount = "DOT Time",
	BotNames = "Ticked on",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Duration"
}

DetailTitles.HOTs={
	TopNames = "Ability Name",
	TopAmount = "HOT Time",
	BotNames = "Ticked on",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Duration"
}

DetailTitles.Interrupts={
	TopNames = "Interrupted Who",
	TopAmount = "Interrupts",
	BotNames = "Interrupted",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Count"
}

DetailTitles.Dispels={
	TopNames = "Who",
	TopAmount = "Dispels",
	BotNames = "Dispelled",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Count"
}

DetailTitles.CC={
	TopNames = "Broke",
	TopAmount = "Count",
	BotNames = "Broke On",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Count"
}

DetailTitles.Gained={
	TopNames = "Ability",
	TopAmount = "Gained",
	BotNames = "From",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Gained"
}

DetailTitles.GainedFrom={
	TopNames = "From",
	TopAmount = "Gained",
	BotNames = "Ability",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Gained"
}


local DataModes={}

function DataModes:DamageReturner(data, num)
	local PetAmount=0
	local Time=data.Fights[Recount.CurDataSet].ActiveTime
	if Recount.db.char.MergePets and data.Pet and Recount.db.char.combatants[data.Pet].Init then
		if Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet] then
			PetAmount=Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet].Damage or 0
			if Time<Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet].ActiveTime then
				Time=Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet].ActiveTime
			end
		end
	end
	
	if num==1 then
		return ((data.Fights[Recount.CurDataSet].Damage or 0) + PetAmount), ((data.Fights[Recount.CurDataSet].Damage or 0) + PetAmount)/Time
	end

	return ((data.Fights[Recount.CurDataSet].Damage or 0)+PetAmount), {{data.Fights[Recount.CurDataSet].Attacks,"'s Hostile Attacks",DetailTitles.Attacks},{data.Fights[Recount.CurDataSet].DamagedWho," Damaged Who",DetailTitles.DamagedWho},{data.Fights[Recount.CurDataSet].PartialResist,"'s Partial Resists",DetailTitles.Resisted},{data.Fights[Recount.CurDataSet].TimeDamaging,"'s Time Spent Attacking",DetailTitles.DamageTime}}
end

function DataModes:DPSReturner(data, num)
	local PetAmount=0
	local Time=data.Fights[Recount.CurDataSet].ActiveTime
	if Recount.db.char.MergePets and data.Pet and Recount.db.char.combatants[data.Pet].Init then
		if Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet] then
			PetAmount=Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet].Damage or 0
			if Time<Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet].ActiveTime then
				Time=Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet].ActiveTime
			end
		end
	end
	
	if num==1 then
		return ((data.Fights[Recount.CurDataSet].Damage or 0) + PetAmount)/Time
	end

	return ((data.Fights[Recount.CurDataSet].Damage or 0) + PetAmount)/Time, {{data.Fights[Recount.CurDataSet].Attacks,"'s Hostile Attacks",DetailTitles.Attacks},{data.Fights[Recount.CurDataSet].DamagedWho," Damaged Who",DetailTitles.DamagedWho},{data.Fights[Recount.CurDataSet].PartialResist,"'s Partial Resists",DetailTitles.Resisted},{data.Fights[Recount.CurDataSet].TimeDamaging,"'s Time Spent Attacking",DetailTitles.DamageTime}}
end


function DataModes:FriendlyDamageReturner(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].FDamage or 0)
	end

	return (data.Fights[Recount.CurDataSet].FDamage or 0), {{data.Fights[Recount.CurDataSet].FAttacks,"'s Friendly Fire",DetailTitles.Attacks},{data.Fights[Recount.CurDataSet].FDamagedWho," Friendly Fired On",DetailTitles.DamagedWho}}
end

function DataModes:DamageTakenReturner(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].DamageTaken or 0)
	end

	return (data.Fights[Recount.CurDataSet].DamageTaken or 0), {{data.Fights[Recount.CurDataSet].WhoDamaged," Took Damage From",DetailTitles.DamagedWho}}
end

function DataModes:HealingReturner(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].Healing or 0), (data.Fights[Recount.CurDataSet].Healing or 0)/data.Fights[Recount.CurDataSet].ActiveTime
	end


	return (data.Fights[Recount.CurDataSet].Healing or 0), {{data.Fights[Recount.CurDataSet].Heals,"'s Effective Healing",DetailTitles.Heals},{data.Fights[Recount.CurDataSet].HealedWho," Healed Who",DetailTitles.HealedWho},{data.Fights[Recount.CurDataSet].OverHeals,"'s Overhealing",DetailTitles.OverHeals},{data.Fights[Recount.CurDataSet].TimeHealing,"'s Time Spent Healing",DetailTitles.HealTime}}
end

function DataModes:HealingTaken(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].HealingTaken or 0)
	end


	return (data.Fights[Recount.CurDataSet].HealingTaken or 0), {{data.Fights[Recount.CurDataSet].WhoHealed," was Healed by",DetailTitles.HealedWho}}
end

function DataModes:OverhealingReturner(data, num)
	if num==1 then
		local OverhealPercent
		OverhealPercent=(math.floor(1000*(data.Fights[Recount.CurDataSet].Overhealing/(data.Fights[Recount.CurDataSet].Overhealing+data.Fights[Recount.CurDataSet].Healing+Epsilon))+0.5)/10).."%"
		return (data.Fights[Recount.CurDataSet].Overhealing or 0), OverhealPercent
	end

	return (data.Fights[Recount.CurDataSet].Overhealing or 0), {{data.Fights[Recount.CurDataSet].OverHeals,"'s Overhealing",DetailTitles.OverHeals},{data.Fights[Recount.CurDataSet].Heals,"'s Effective Healing",DetailTitles.Heals},{data.Fights[Recount.CurDataSet].HealedWho," Healed Who",DetailTitles.HealedWho}}
end

function DataModes:DeathReturner(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].DeathCount or 0)
	end

	return (data.Fights[Recount.CurDataSet].DeathCount or 0), {{data.DeathLogs, Recount.SetDeathDetails, Recount.SetDeathLogDetails}}
end

function DataModes:DOTReturner(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].DOT_Time or 0), (data.Fights[Recount.CurDataSet].DOT_Time or 0)/data.Fights[Recount.CurDataSet].ActiveTime
	end

	return (data.Fights[Recount.CurDataSet].DOT_Time or 0), {{data.Fights[Recount.CurDataSet].DOTs,"'s DOT Uptime",DetailTitles.DOTs}}
end

function DataModes:HOTReturner(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].HOT_Time or 0), (data.Fights[Recount.CurDataSet].HOT_Time or 0)/data.Fights[Recount.CurDataSet].ActiveTime
	end

	return (data.Fights[Recount.CurDataSet].HOT_Time or 0), {{data.Fights[Recount.CurDataSet].HOTs,"'s HOT Uptime",DetailTitles.HOTs}}
end

function DataModes:InterruptReturner(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].Interrupts or 0)
	end

	return (data.Fights[Recount.CurDataSet].Interrupts or 0), {{data.Fights[Recount.CurDataSet].InterruptData,"'s Interrupts",DetailTitles.Interrupts}}
end

function DataModes:Dispels(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].Dispels or 0)
	end

	return (data.Fights[Recount.CurDataSet].Dispels or 0), {{data.Fights[Recount.CurDataSet].DispelledWho,"'s Dispels",DetailTitles.Dispels}}
end

function DataModes:Dispelled(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].Dispelled or 0)
	end

	return (data.Fights[Recount.CurDataSet].Dispelled or 0), {{data.Fights[Recount.CurDataSet].WhoDispelled," was Dispelled by",DetailTitles.Dispels}}
end

function DataModes:ActiveTime(data, num)
	if num==1 then
		return (math.floor(data.Fights[Recount.CurDataSet].ActiveTime*100)/100 or 0)
	end

	return (math.floor(data.Fights[Recount.CurDataSet].ActiveTime*100)/100 or 0), {{data.Fights[Recount.CurDataSet].TimeSpent,"'s Time Spent",DetailTitles.ActiveTime},{data.Fights[Recount.CurDataSet].TimeDamaging,"'s Time Spent Attacking",DetailTitles.DamageTime},{data.Fights[Recount.CurDataSet].TimeHealing,"'s Time Spent Healing",DetailTitles.HealTime}}
end

function DataModes:PolyBreak(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].CCBreak or 0)
	end
	return (data.Fights[Recount.CurDataSet].CCBreak or 0), {{data.Fights[Recount.CurDataSet].CCBroken," CC Breaking",DetailTitles.CC}}
end

function DataModes:ManaGained(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].ManaGain or 0)
	end
	return (data.Fights[Recount.CurDataSet].ManaGain or 0), {{data.Fights[Recount.CurDataSet].ManaGained,"'s Mana Gained",DetailTitles.Gained},{data.Fights[Recount.CurDataSet].ManaGainedFrom,"'s Mana Gained From",DetailTitles.GainedFrom}}
end

function DataModes:EnergyGained(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].EnergyGain or 0)
	end
	return (data.Fights[Recount.CurDataSet].EnergyGain or 0), {{data.Fights[Recount.CurDataSet].EnergyGained,"'s Energy Gained",DetailTitles.Gained},{data.Fights[Recount.CurDataSet].EnergyGainedFrom,"'s Energy Gained From",DetailTitles.GainedFrom}}
end

function DataModes:RageGained(data, num)
	if num==1 then
		return (data.Fights[Recount.CurDataSet].RageGain or 0)
	end
	return (data.Fights[Recount.CurDataSet].RageGain or 0), {{data.Fights[Recount.CurDataSet].RageGained,"'s Rage Gained",DetailTitles.Gained},{data.Fights[Recount.CurDataSet].RageGainedFrom,"'s Rage Gained From",DetailTitles.GainedFrom}}
end


function DataModes:Threat(data)
	--[[local ThreatAmount
	
	if Recount.ThreatActive then
		ThreatAmount=threat:GetThreat(data.Name,Recount.ThreatTargetName)
		
		return ThreatAmount
	end]]
	if Recount.InCombat then
		return (data.Fights[Recount.CurDataSet].Threat or 0)
	end

	return (data.Fights[Recount.CurDataSet].ThreatNonZero or 0)
end

local SpecialTotals={}
function SpecialTotals:Threat()
	if Recount.ThreatActive then
		if Recount.ThreatTarget and Recount.ThreatTarget~=threat.GlobalTarget and UnitExists(Recount.ThreatTarget.."target") then
			local t=threat:GetThreat(UnitName(Recount.ThreatTarget.."target"),Recount.ThreatTargetName)
			if t>0 then
				return t
			end
		end
		return threat:GetMaxThreatOnTarget(Recount.ThreatTargetName)
	end
	return 1
end




--Some code for table management from Ace2
local new, del
do
	local cache = setmetatable({},{__mode='k'})
	function new()
		local t = next(cache)
		if t then
			cache[t] = nil
			return t
		else
			return {}
		end
	end
	
	function del(t)
		for k in pairs(t) do
			t[k] = nil
		end
		cache[t] = true
		return nil
	end
end



function Recount:AddSortedTooltipData(title,data,num)
	local SortedData=Recount:GetTable()
	GameTooltip:AddLine(title,1,0.82,0)

	local total=Epsilon
	local i=0
	for k,v in pairs(data) do
		if v.amount then
			i=i+1
			if not SortedData[i] then
				SortedData[i]=Recount:GetTable()
			end
			SortedData[i][1]=k
			SortedData[i][2]=v.amount
			
			total=total+v.amount
		end		
	end

	if num>i then
		num=i
	end

	table.sort(SortedData,RecountSortFunc)

	for i=1,num do
		if SortedData[i] then
			GameTooltip:AddDoubleLine(i..". "..SortedData[i][1],SortedData[i][2].." ("..math.floor(100*SortedData[i][2]/total).."%)",1,1,1,1,1,1)
		end
	end

	Recount:FreeTableRecurse(SortedData)
end
--The various tooltip functions used for each of the main window data displays
local TooltipFuncs={}
function TooltipFuncs:Damage(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Damage Abilties",data.Fights[Recount.CurDataSet].Attacks,3)
	GameTooltip:AddLine("")
	Recount:AddSortedTooltipData("Top 3 Attacked",data.Fights[Recount.CurDataSet].DamagedWho,3)
	if Recount.db.char.MergePets and data.Pet and Recount.db.char.combatants[data.Pet].Init then
		if Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet] then
			local Damage=Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet].Damage or 0 
			Damage=Damage/(Damage+(data.Fights[Recount.CurDataSet].Damage or 0))
			GameTooltip:AddLine(" ")
			GameTooltip:AddDoubleLine("Pet:",data.Pet.." ("..math.floor(Damage*100+0.5).."%)",nil,nil,nil,1,1,1)
			Recount:AddSortedTooltipData("Top 3 Pet Damage Abilties",Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet].Attacks,3)
			GameTooltip:AddLine("")
			Recount:AddSortedTooltipData("Top 3 Pet Attacked",Recount.db.char.combatants[data.Pet].Fights[Recount.CurDataSet].DamagedWho,3)
		end
	end

	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:FDamage(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Friendly Attacks",data.Fights[Recount.CurDataSet].FAttacks,3)
	GameTooltip:AddLine("")
	Recount:AddSortedTooltipData("Top 3 Friendly Fired On",data.Fights[Recount.CurDataSet].FDamagedWho,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:DamageTaken(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Attacked by",data.Fights[Recount.CurDataSet].WhoDamaged,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:Healing(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Heals",data.Fights[Recount.CurDataSet].Heals,3)
	GameTooltip:AddLine("")
	Recount:AddSortedTooltipData("Top 3 Healed",data.Fights[Recount.CurDataSet].HealedWho,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:HealingTaken(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Healed By",data.Fights[Recount.CurDataSet].WhoHealed,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:Overhealing(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Over Heals",data.Fights[Recount.CurDataSet].OverHeals,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:DOTs(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 DOTs",data.Fights[Recount.CurDataSet].DOTs,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:HOTs(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 DOTs",data.Fights[Recount.CurDataSet].HOTs,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:Interrupts(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Interrupted",data.Fights[Recount.CurDataSet].InterruptData,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:Dispels(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Dispelled",data.Fights[Recount.CurDataSet].DispelledWho,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:Dispelled(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Dispelled By",data.Fights[Recount.CurDataSet].WhoDispelled,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:ActiveTime(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Attacked/Healed",data.Fights[Recount.CurDataSet].TimeSpent,3)
	local Heal,Damage
	Heal=data.Fights[Recount.CurDataSet].TimeHeal
	Damage=data.Fights[Recount.CurDataSet].TimeDamage
	local Total=Heal+Damage+Epsilon
	Heal=100*Heal/Total
	Damage=100*Damage/Total
	GameTooltip:AddDoubleLine("Time Damaging:",math.floor(Damage+0.5).."%",nil,nil,nil,1,1,1)
	GameTooltip:AddDoubleLine("Time Healing:",math.floor(Heal+0.5).."%",nil,nil,nil,1,1,1)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:ManaGained(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Mana Abilities",data.Fights[Recount.CurDataSet].ManaGained,3)
	Recount:AddSortedTooltipData("Top 3 Mana Sources",data.Fights[Recount.CurDataSet].ManaGainedFrom,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:EnergyGained(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Energy Abilities",data.Fights[Recount.CurDataSet].EnergyGained,3)
	Recount:AddSortedTooltipData("Top 3 Energy Sources",data.Fights[Recount.CurDataSet].EnergyGainedFrom,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:RageGained(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 Rage Abilities",data.Fights[Recount.CurDataSet].RageGained,3)
	Recount:AddSortedTooltipData("Top 3 Rage Sources",data.Fights[Recount.CurDataSet].RageGainedFrom,3)
	GameTooltip:AddLine("<Click for more Details>",0,0.9,0)
end

function TooltipFuncs:Threat(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
end

function TooltipFuncs:DeathCounts(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	GameTooltip:Hide()
end

function TooltipFuncs:CCBroken(name,data)
	local SortedData,total
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData("Top 3 CC's Broken",data.Fights[Recount.CurDataSet].CCBroken,3)
end


local MainWindowModes={
{"Damage Done",DataModes.DamageReturner,TooltipFuncs.Damage,nil,{"DAMAGE","'s DPS"},nil,"Damage"},
{"DPS",DataModes.DPSReturner,TooltipFuncs.Damage,nil,{"DAMAGE","'s DPS"},nil,"Damage"},
{"Friendly Fire",DataModes.FriendlyDamageReturner,TooltipFuncs.FDamage},
{"Damage Taken",DataModes.DamageTakenReturner,TooltipFuncs.DamageTaken,nil,{"DAMAGETAKEN","'s DTPS"},nil,"DamageTaken"},
{"Healing Done",DataModes.HealingReturner,TooltipFuncs.Healing,nil,{"HEALING","'s HPS"},nil,"Healing"},
{"Healing Taken",DataModes.HealingTaken,TooltipFuncs.HealingTaken,nil,{"HEALINGTAKEN","'s HTPS"},nil,"HealingTaken"},
{"Overhealing Done",DataModes.OverhealingReturner,TooltipFuncs.Overhealing},
{"Deaths",DataModes.DeathReturner,TooltipFuncs.DeathCounts},
{"DOT Uptime",DataModes.DOTReturner,TooltipFuncs.DOTs,nil,nil,nil,nil},
{"HOT Uptime",DataModes.HOTReturner,TooltipFuncs.HOTs,nil,nil,nil,nil},
{"Dispels",DataModes.Dispels,TooltipFuncs.Dispels,nil,nil,nil,nil},
{"Dispelled",DataModes.Dispelled,TooltipFuncs.Dispelled,nil,nil,nil,nil},
{"Interrupts",DataModes.InterruptReturner,TooltipFuncs.Interrupts,nil,nil,nil,nil},
{"CC Breakers",DataModes.PolyBreak,TooltipFuncs.CCBroken,nil,nil,nil,nil},
{"Activity",DataModes.ActiveTime,TooltipFuncs.ActiveTime,nil,nil,nil,nil},
{"Threat",DataModes.Threat,TooltipFuncs.Threat,SpecialTotals.Threat,{"THREAT","'s TPS"}, function() return "Threat on "..Recount.ThreatTargetName end, "Threat"},
{"Mana Gained",DataModes.ManaGained,TooltipFuncs.ManaGained},
{"Energy Gained",DataModes.EnergyGained,TooltipFuncs.EnergyGained},
{"Rage Gained",DataModes.RageGained,TooltipFuncs.RageGained},
}

function Recount:SetupMainWindow()
	Recount:LoadMainWindowData(MainWindowModes)	
end